]> rtime.felk.cvut.cz Git - git.git/blob - git-rebase--interactive.sh
rebase -i: teach --onto A...B syntax
[git.git] / git-rebase--interactive.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2006 Johannes E. Schindelin
4
5 # SHORT DESCRIPTION
6 #
7 # This script makes it easy to fix up commits in the middle of a series,
8 # and rearrange commits.
9 #
10 # The original idea comes from Eric W. Biederman, in
11 # http://article.gmane.org/gmane.comp.version-control.git/22407
12
13 OPTIONS_KEEPDASHDASH=
14 OPTIONS_SPEC="\
15 git-rebase [-i] [options] [--] <upstream> [<branch>]
16 git-rebase [-i] (--continue | --abort | --skip)
17 --
18  Available options are
19 v,verbose          display a diffstat of what changed upstream
20 onto=              rebase onto given branch instead of upstream
21 p,preserve-merges  try to recreate merges instead of ignoring them
22 s,strategy=        use the given merge strategy
23 m,merge            always used (no-op)
24 i,interactive      always used (no-op)
25  Actions:
26 continue           continue rebasing process
27 abort              abort rebasing process and restore original branch
28 skip               skip current patch and continue rebasing process
29 no-verify          override pre-rebase hook from stopping the operation
30 root               rebase all reachable commmits up to the root(s)
31 "
32
33 . git-sh-setup
34 require_work_tree
35
36 DOTEST="$GIT_DIR/rebase-merge"
37 TODO="$DOTEST"/git-rebase-todo
38 DONE="$DOTEST"/done
39 MSG="$DOTEST"/message
40 SQUASH_MSG="$DOTEST"/message-squash
41 REWRITTEN="$DOTEST"/rewritten
42 DROPPED="$DOTEST"/dropped
43 PRESERVE_MERGES=
44 STRATEGY=
45 ONTO=
46 VERBOSE=
47 OK_TO_SKIP_PRE_REBASE=
48 REBASE_ROOT=
49
50 GIT_CHERRY_PICK_HELP="  After resolving the conflicts,
51 mark the corrected paths with 'git add <paths>', and
52 run 'git rebase --continue'"
53 export GIT_CHERRY_PICK_HELP
54
55 warn () {
56         echo "$*" >&2
57 }
58
59 output () {
60         case "$VERBOSE" in
61         '')
62                 output=$("$@" 2>&1 )
63                 status=$?
64                 test $status != 0 && printf "%s\n" "$output"
65                 return $status
66                 ;;
67         *)
68                 "$@"
69                 ;;
70         esac
71 }
72
73 run_pre_rebase_hook () {
74         if test -z "$OK_TO_SKIP_PRE_REBASE" &&
75            test -x "$GIT_DIR/hooks/pre-rebase"
76         then
77                 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
78                         echo >&2 "The pre-rebase hook refused to rebase."
79                         exit 1
80                 }
81         fi
82 }
83
84 require_clean_work_tree () {
85         # test if working tree is dirty
86         git rev-parse --verify HEAD > /dev/null &&
87         git update-index --ignore-submodules --refresh &&
88         git diff-files --quiet --ignore-submodules &&
89         git diff-index --cached --quiet HEAD --ignore-submodules -- ||
90         die "Working tree is dirty"
91 }
92
93 ORIG_REFLOG_ACTION="$GIT_REFLOG_ACTION"
94
95 comment_for_reflog () {
96         case "$ORIG_REFLOG_ACTION" in
97         ''|rebase*)
98                 GIT_REFLOG_ACTION="rebase -i ($1)"
99                 export GIT_REFLOG_ACTION
100                 ;;
101         esac
102 }
103
104 last_count=
105 mark_action_done () {
106         sed -e 1q < "$TODO" >> "$DONE"
107         sed -e 1d < "$TODO" >> "$TODO".new
108         mv -f "$TODO".new "$TODO"
109         count=$(grep -c '^[^#]' < "$DONE")
110         total=$(($count+$(grep -c '^[^#]' < "$TODO")))
111         if test "$last_count" != "$count"
112         then
113                 last_count=$count
114                 printf "Rebasing (%d/%d)\r" $count $total
115                 test -z "$VERBOSE" || echo
116         fi
117 }
118
119 make_patch () {
120         sha1_and_parents="$(git rev-list --parents -1 "$1")"
121         case "$sha1_and_parents" in
122         ?*' '?*' '?*)
123                 git diff --cc $sha1_and_parents
124                 ;;
125         ?*' '?*)
126                 git diff-tree -p "$1^!"
127                 ;;
128         *)
129                 echo "Root commit"
130                 ;;
131         esac > "$DOTEST"/patch
132         test -f "$DOTEST"/message ||
133                 git cat-file commit "$1" | sed "1,/^$/d" > "$DOTEST"/message
134         test -f "$DOTEST"/author-script ||
135                 get_author_ident_from_commit "$1" > "$DOTEST"/author-script
136 }
137
138 die_with_patch () {
139         make_patch "$1"
140         git rerere
141         die "$2"
142 }
143
144 die_abort () {
145         rm -rf "$DOTEST"
146         die "$1"
147 }
148
149 has_action () {
150         grep '^[^#]' "$1" >/dev/null
151 }
152
153 pick_one () {
154         no_ff=
155         case "$1" in -n) sha1=$2; no_ff=t ;; *) sha1=$1 ;; esac
156         output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
157         test -d "$REWRITTEN" &&
158                 pick_one_preserving_merges "$@" && return
159         if test ! -z "$REBASE_ROOT"
160         then
161                 output git cherry-pick "$@"
162                 return
163         fi
164         parent_sha1=$(git rev-parse --verify $sha1^) ||
165                 die "Could not get the parent of $sha1"
166         current_sha1=$(git rev-parse --verify HEAD)
167         if test "$no_ff$current_sha1" = "$parent_sha1"; then
168                 output git reset --hard $sha1
169                 test "a$1" = a-n && output git reset --soft $current_sha1
170                 sha1=$(git rev-parse --short $sha1)
171                 output warn Fast forward to $sha1
172         else
173                 output git cherry-pick "$@"
174         fi
175 }
176
177 pick_one_preserving_merges () {
178         fast_forward=t
179         case "$1" in
180         -n)
181                 fast_forward=f
182                 sha1=$2
183                 ;;
184         *)
185                 sha1=$1
186                 ;;
187         esac
188         sha1=$(git rev-parse $sha1)
189
190         if test -f "$DOTEST"/current-commit
191         then
192                 if test "$fast_forward" = t
193                 then
194                         cat "$DOTEST"/current-commit | while read current_commit
195                         do
196                                 git rev-parse HEAD > "$REWRITTEN"/$current_commit
197                         done
198                         rm "$DOTEST"/current-commit ||
199                         die "Cannot write current commit's replacement sha1"
200                 fi
201         fi
202
203         echo $sha1 >> "$DOTEST"/current-commit
204
205         # rewrite parents; if none were rewritten, we can fast-forward.
206         new_parents=
207         pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
208         if test "$pend" = " "
209         then
210                 pend=" root"
211         fi
212         while [ "$pend" != "" ]
213         do
214                 p=$(expr "$pend" : ' \([^ ]*\)')
215                 pend="${pend# $p}"
216
217                 if test -f "$REWRITTEN"/$p
218                 then
219                         new_p=$(cat "$REWRITTEN"/$p)
220
221                         # If the todo reordered commits, and our parent is marked for
222                         # rewriting, but hasn't been gotten to yet, assume the user meant to
223                         # drop it on top of the current HEAD
224                         if test -z "$new_p"
225                         then
226                                 new_p=$(git rev-parse HEAD)
227                         fi
228
229                         test $p != $new_p && fast_forward=f
230                         case "$new_parents" in
231                         *$new_p*)
232                                 ;; # do nothing; that parent is already there
233                         *)
234                                 new_parents="$new_parents $new_p"
235                                 ;;
236                         esac
237                 else
238                         if test -f "$DROPPED"/$p
239                         then
240                                 fast_forward=f
241                                 replacement="$(cat "$DROPPED"/$p)"
242                                 test -z "$replacement" && replacement=root
243                                 pend=" $replacement$pend"
244                         else
245                                 new_parents="$new_parents $p"
246                         fi
247                 fi
248         done
249         case $fast_forward in
250         t)
251                 output warn "Fast forward to $sha1"
252                 output git reset --hard $sha1 ||
253                         die "Cannot fast forward to $sha1"
254                 ;;
255         f)
256                 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
257
258                 if [ "$1" != "-n" ]
259                 then
260                         # detach HEAD to current parent
261                         output git checkout $first_parent 2> /dev/null ||
262                                 die "Cannot move HEAD to $first_parent"
263                 fi
264
265                 case "$new_parents" in
266                 ' '*' '*)
267                         test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
268
269                         # redo merge
270                         author_script=$(get_author_ident_from_commit $sha1)
271                         eval "$author_script"
272                         msg="$(git cat-file commit $sha1 | sed -e '1,/^$/d')"
273                         # No point in merging the first parent, that's HEAD
274                         new_parents=${new_parents# $first_parent}
275                         if ! GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
276                                 GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
277                                 GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
278                                 output git merge $STRATEGY -m "$msg" \
279                                         $new_parents
280                         then
281                                 printf "%s\n" "$msg" > "$GIT_DIR"/MERGE_MSG
282                                 die_with_patch $sha1 "Error redoing merge $sha1"
283                         fi
284                         ;;
285                 *)
286                         output git cherry-pick "$@" ||
287                                 die_with_patch $sha1 "Could not pick $sha1"
288                         ;;
289                 esac
290                 ;;
291         esac
292 }
293
294 nth_string () {
295         case "$1" in
296         *1[0-9]|*[04-9]) echo "$1"th;;
297         *1) echo "$1"st;;
298         *2) echo "$1"nd;;
299         *3) echo "$1"rd;;
300         esac
301 }
302
303 make_squash_message () {
304         if test -f "$SQUASH_MSG"; then
305                 COUNT=$(($(sed -n "s/^# This is [^0-9]*\([1-9][0-9]*\).*/\1/p" \
306                         < "$SQUASH_MSG" | sed -ne '$p')+1))
307                 echo "# This is a combination of $COUNT commits."
308                 sed -e 1d -e '2,/^./{
309                         /^$/d
310                 }' <"$SQUASH_MSG"
311         else
312                 COUNT=2
313                 echo "# This is a combination of two commits."
314                 echo "# The first commit's message is:"
315                 echo
316                 git cat-file commit HEAD | sed -e '1,/^$/d'
317         fi
318         echo
319         echo "# This is the $(nth_string $COUNT) commit message:"
320         echo
321         git cat-file commit $1 | sed -e '1,/^$/d'
322 }
323
324 peek_next_command () {
325         sed -n "1s/ .*$//p" < "$TODO"
326 }
327
328 do_next () {
329         rm -f "$DOTEST"/message "$DOTEST"/author-script \
330                 "$DOTEST"/amend || exit
331         read command sha1 rest < "$TODO"
332         case "$command" in
333         '#'*|''|noop)
334                 mark_action_done
335                 ;;
336         pick|p)
337                 comment_for_reflog pick
338
339                 mark_action_done
340                 pick_one $sha1 ||
341                         die_with_patch $sha1 "Could not apply $sha1... $rest"
342                 ;;
343         edit|e)
344                 comment_for_reflog edit
345
346                 mark_action_done
347                 pick_one $sha1 ||
348                         die_with_patch $sha1 "Could not apply $sha1... $rest"
349                 make_patch $sha1
350                 git rev-parse --verify HEAD > "$DOTEST"/amend
351                 warn "Stopped at $sha1... $rest"
352                 warn "You can amend the commit now, with"
353                 warn
354                 warn "  git commit --amend"
355                 warn
356                 warn "Once you are satisfied with your changes, run"
357                 warn
358                 warn "  git rebase --continue"
359                 warn
360                 exit 0
361                 ;;
362         squash|s)
363                 comment_for_reflog squash
364
365                 test -f "$DONE" && has_action "$DONE" ||
366                         die "Cannot 'squash' without a previous commit"
367
368                 mark_action_done
369                 make_squash_message $sha1 > "$MSG"
370                 failed=f
371                 author_script=$(get_author_ident_from_commit HEAD)
372                 output git reset --soft HEAD^
373                 pick_one -n $sha1 || failed=t
374                 case "$(peek_next_command)" in
375                 squash|s)
376                         USE_OUTPUT=output
377                         MSG_OPT=-F
378                         EDIT_OR_FILE="$MSG"
379                         cp "$MSG" "$SQUASH_MSG"
380                         ;;
381                 *)
382                         USE_OUTPUT=
383                         MSG_OPT=
384                         EDIT_OR_FILE=-e
385                         rm -f "$SQUASH_MSG" || exit
386                         cp "$MSG" "$GIT_DIR"/SQUASH_MSG
387                         rm -f "$GIT_DIR"/MERGE_MSG || exit
388                         ;;
389                 esac
390                 echo "$author_script" > "$DOTEST"/author-script
391                 if test $failed = f
392                 then
393                         # This is like --amend, but with a different message
394                         eval "$author_script"
395                         GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
396                         GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
397                         GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
398                         $USE_OUTPUT git commit --no-verify \
399                                 $MSG_OPT "$EDIT_OR_FILE" || failed=t
400                 fi
401                 if test $failed = t
402                 then
403                         cp "$MSG" "$GIT_DIR"/MERGE_MSG
404                         warn
405                         warn "Could not apply $sha1... $rest"
406                         die_with_patch $sha1 ""
407                 fi
408                 ;;
409         *)
410                 warn "Unknown command: $command $sha1 $rest"
411                 die_with_patch $sha1 "Please fix this in the file $TODO."
412                 ;;
413         esac
414         test -s "$TODO" && return
415
416         comment_for_reflog finish &&
417         HEADNAME=$(cat "$DOTEST"/head-name) &&
418         OLDHEAD=$(cat "$DOTEST"/head) &&
419         SHORTONTO=$(git rev-parse --short $(cat "$DOTEST"/onto)) &&
420         NEWHEAD=$(git rev-parse HEAD) &&
421         case $HEADNAME in
422         refs/*)
423                 message="$GIT_REFLOG_ACTION: $HEADNAME onto $SHORTONTO" &&
424                 git update-ref -m "$message" $HEADNAME $NEWHEAD $OLDHEAD &&
425                 git symbolic-ref HEAD $HEADNAME
426                 ;;
427         esac && {
428                 test ! -f "$DOTEST"/verbose ||
429                         git diff-tree --stat $(cat "$DOTEST"/head)..HEAD
430         } &&
431         rm -rf "$DOTEST" &&
432         git gc --auto &&
433         warn "Successfully rebased and updated $HEADNAME."
434
435         exit
436 }
437
438 do_rest () {
439         while :
440         do
441                 do_next
442         done
443 }
444
445 # skip picking commits whose parents are unchanged
446 skip_unnecessary_picks () {
447         fd=3
448         while read command sha1 rest
449         do
450                 # fd=3 means we skip the command
451                 case "$fd,$command,$(git rev-parse --verify --quiet $sha1^)" in
452                 3,pick,"$ONTO"*|3,p,"$ONTO"*)
453                         # pick a commit whose parent is current $ONTO -> skip
454                         ONTO=$sha1
455                         ;;
456                 3,#*|3,,*)
457                         # copy comments
458                         ;;
459                 *)
460                         fd=1
461                         ;;
462                 esac
463                 echo "$command${sha1:+ }$sha1${rest:+ }$rest" >&$fd
464         done <"$TODO" >"$TODO.new" 3>>"$DONE" &&
465         mv -f "$TODO".new "$TODO" ||
466         die "Could not skip unnecessary pick commands"
467 }
468
469 # check if no other options are set
470 is_standalone () {
471         test $# -eq 2 -a "$2" = '--' &&
472         test -z "$ONTO" &&
473         test -z "$PRESERVE_MERGES" &&
474         test -z "$STRATEGY" &&
475         test -z "$VERBOSE"
476 }
477
478 get_saved_options () {
479         test -d "$REWRITTEN" && PRESERVE_MERGES=t
480         test -f "$DOTEST"/strategy && STRATEGY="$(cat "$DOTEST"/strategy)"
481         test -f "$DOTEST"/verbose && VERBOSE=t
482         test -f "$DOTEST"/rebase-root && REBASE_ROOT=t
483 }
484
485 LF='
486 '
487 parse_onto () {
488         case "$1" in
489         *...*)
490                 if      left=${1%...*} right=${1#*...} &&
491                         onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
492                 then
493                         case "$onto" in
494                         ?*"$LF"?* | '')
495                                 exit 1 ;;
496                         esac
497                         echo "$onto"
498                         exit 0
499                 fi
500         esac
501         git rev-parse --verify "$1^0"
502 }
503
504 while test $# != 0
505 do
506         case "$1" in
507         --no-verify)
508                 OK_TO_SKIP_PRE_REBASE=yes
509                 ;;
510         --verify)
511                 ;;
512         --continue)
513                 is_standalone "$@" || usage
514                 get_saved_options
515                 comment_for_reflog continue
516
517                 test -d "$DOTEST" || die "No interactive rebase running"
518
519                 # Sanity check
520                 git rev-parse --verify HEAD >/dev/null ||
521                         die "Cannot read HEAD"
522                 git update-index --ignore-submodules --refresh &&
523                         git diff-files --quiet --ignore-submodules ||
524                         die "Working tree is dirty"
525
526                 # do we have anything to commit?
527                 if git diff-index --cached --quiet --ignore-submodules HEAD --
528                 then
529                         : Nothing to commit -- skip this
530                 else
531                         . "$DOTEST"/author-script ||
532                                 die "Cannot find the author identity"
533                         amend=
534                         if test -f "$DOTEST"/amend
535                         then
536                                 amend=$(git rev-parse --verify HEAD)
537                                 test "$amend" = $(cat "$DOTEST"/amend) ||
538                                 die "\
539 You have uncommitted changes in your working tree. Please, commit them
540 first and then run 'git rebase --continue' again."
541                                 git reset --soft HEAD^ ||
542                                 die "Cannot rewind the HEAD"
543                         fi
544                         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE &&
545                         git commit --no-verify -F "$DOTEST"/message -e || {
546                                 test -n "$amend" && git reset --soft $amend
547                                 die "Could not commit staged changes."
548                         }
549                 fi
550
551                 require_clean_work_tree
552                 do_rest
553                 ;;
554         --abort)
555                 is_standalone "$@" || usage
556                 get_saved_options
557                 comment_for_reflog abort
558
559                 git rerere clear
560                 test -d "$DOTEST" || die "No interactive rebase running"
561
562                 HEADNAME=$(cat "$DOTEST"/head-name)
563                 HEAD=$(cat "$DOTEST"/head)
564                 case $HEADNAME in
565                 refs/*)
566                         git symbolic-ref HEAD $HEADNAME
567                         ;;
568                 esac &&
569                 output git reset --hard $HEAD &&
570                 rm -rf "$DOTEST"
571                 exit
572                 ;;
573         --skip)
574                 is_standalone "$@" || usage
575                 get_saved_options
576                 comment_for_reflog skip
577
578                 git rerere clear
579                 test -d "$DOTEST" || die "No interactive rebase running"
580
581                 output git reset --hard && do_rest
582                 ;;
583         -s)
584                 case "$#,$1" in
585                 *,*=*)
586                         STRATEGY="-s "$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
587                 1,*)
588                         usage ;;
589                 *)
590                         STRATEGY="-s $2"
591                         shift ;;
592                 esac
593                 ;;
594         -m)
595                 # we use merge anyway
596                 ;;
597         -v)
598                 VERBOSE=t
599                 ;;
600         -p)
601                 PRESERVE_MERGES=t
602                 ;;
603         -i)
604                 # yeah, we know
605                 ;;
606         --root)
607                 REBASE_ROOT=t
608                 ;;
609         --onto)
610                 shift
611                 ONTO=$(parse_onto "$1") ||
612                         die "Does not point to a valid commit: $1"
613                 ;;
614         --)
615                 shift
616                 test -z "$REBASE_ROOT" -a $# -ge 1 -a $# -le 2 ||
617                 test ! -z "$REBASE_ROOT" -a $# -le 1 || usage
618                 test -d "$DOTEST" &&
619                         die "Interactive rebase already started"
620
621                 git var GIT_COMMITTER_IDENT >/dev/null ||
622                         die "You need to set your committer info first"
623
624                 if test -z "$REBASE_ROOT"
625                 then
626                         UPSTREAM_ARG="$1"
627                         UPSTREAM=$(git rev-parse --verify "$1") || die "Invalid base"
628                         test -z "$ONTO" && ONTO=$UPSTREAM
629                         shift
630                 else
631                         UPSTREAM=
632                         UPSTREAM_ARG=--root
633                         test -z "$ONTO" &&
634                                 die "You must specify --onto when using --root"
635                 fi
636                 run_pre_rebase_hook "$UPSTREAM_ARG" "$@"
637
638                 comment_for_reflog start
639
640                 require_clean_work_tree
641
642                 if test ! -z "$1"
643                 then
644                         output git show-ref --verify --quiet "refs/heads/$1" ||
645                                 die "Invalid branchname: $1"
646                         output git checkout "$1" ||
647                                 die "Could not checkout $1"
648                 fi
649
650                 HEAD=$(git rev-parse --verify HEAD) || die "No HEAD?"
651                 mkdir "$DOTEST" || die "Could not create temporary $DOTEST"
652
653                 : > "$DOTEST"/interactive || die "Could not mark as interactive"
654                 git symbolic-ref HEAD > "$DOTEST"/head-name 2> /dev/null ||
655                         echo "detached HEAD" > "$DOTEST"/head-name
656
657                 echo $HEAD > "$DOTEST"/head
658                 case "$REBASE_ROOT" in
659                 '')
660                         rm -f "$DOTEST"/rebase-root ;;
661                 *)
662                         : >"$DOTEST"/rebase-root ;;
663                 esac
664                 echo $ONTO > "$DOTEST"/onto
665                 test -z "$STRATEGY" || echo "$STRATEGY" > "$DOTEST"/strategy
666                 test t = "$VERBOSE" && : > "$DOTEST"/verbose
667                 if test t = "$PRESERVE_MERGES"
668                 then
669                         # $REWRITTEN contains files for each commit that is
670                         # reachable by at least one merge base of $HEAD and
671                         # $UPSTREAM. They are not necessarily rewritten, but
672                         # their children might be.
673                         # This ensures that commits on merged, but otherwise
674                         # unrelated side branches are left alone. (Think "X"
675                         # in the man page's example.)
676                         if test -z "$REBASE_ROOT"
677                         then
678                                 mkdir "$REWRITTEN" &&
679                                 for c in $(git merge-base --all $HEAD $UPSTREAM)
680                                 do
681                                         echo $ONTO > "$REWRITTEN"/$c ||
682                                                 die "Could not init rewritten commits"
683                                 done
684                         else
685                                 mkdir "$REWRITTEN" &&
686                                 echo $ONTO > "$REWRITTEN"/root ||
687                                         die "Could not init rewritten commits"
688                         fi
689                         # No cherry-pick because our first pass is to determine
690                         # parents to rewrite and skipping dropped commits would
691                         # prematurely end our probe
692                         MERGES_OPTION=
693                         first_after_upstream="$(git rev-list --reverse --first-parent $UPSTREAM..$HEAD | head -n 1)"
694                 else
695                         MERGES_OPTION="--no-merges --cherry-pick"
696                 fi
697
698                 SHORTHEAD=$(git rev-parse --short $HEAD)
699                 SHORTONTO=$(git rev-parse --short $ONTO)
700                 if test -z "$REBASE_ROOT"
701                         # this is now equivalent to ! -z "$UPSTREAM"
702                 then
703                         SHORTUPSTREAM=$(git rev-parse --short $UPSTREAM)
704                         REVISIONS=$UPSTREAM...$HEAD
705                         SHORTREVISIONS=$SHORTUPSTREAM..$SHORTHEAD
706                 else
707                         REVISIONS=$ONTO...$HEAD
708                         SHORTREVISIONS=$SHORTHEAD
709                 fi
710                 git rev-list $MERGES_OPTION --pretty=oneline --abbrev-commit \
711                         --abbrev=7 --reverse --left-right --topo-order \
712                         $REVISIONS | \
713                         sed -n "s/^>//p" | while read shortsha1 rest
714                 do
715                         if test t != "$PRESERVE_MERGES"
716                         then
717                                 echo "pick $shortsha1 $rest" >> "$TODO"
718                         else
719                                 sha1=$(git rev-parse $shortsha1)
720                                 if test -z "$REBASE_ROOT"
721                                 then
722                                         preserve=t
723                                         for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
724                                         do
725                                                 if test -f "$REWRITTEN"/$p -a \( $p != $ONTO -o $sha1 = $first_after_upstream \)
726                                                 then
727                                                         preserve=f
728                                                 fi
729                                         done
730                                 else
731                                         preserve=f
732                                 fi
733                                 if test f = "$preserve"
734                                 then
735                                         touch "$REWRITTEN"/$sha1
736                                         echo "pick $shortsha1 $rest" >> "$TODO"
737                                 fi
738                         fi
739                 done
740
741                 # Watch for commits that been dropped by --cherry-pick
742                 if test t = "$PRESERVE_MERGES"
743                 then
744                         mkdir "$DROPPED"
745                         # Save all non-cherry-picked changes
746                         git rev-list $REVISIONS --left-right --cherry-pick | \
747                                 sed -n "s/^>//p" > "$DOTEST"/not-cherry-picks
748                         # Now all commits and note which ones are missing in
749                         # not-cherry-picks and hence being dropped
750                         git rev-list $REVISIONS |
751                         while read rev
752                         do
753                                 if test -f "$REWRITTEN"/$rev -a "$(grep "$rev" "$DOTEST"/not-cherry-picks)" = ""
754                                 then
755                                         # Use -f2 because if rev-list is telling us this commit is
756                                         # not worthwhile, we don't want to track its multiple heads,
757                                         # just the history of its first-parent for others that will
758                                         # be rebasing on top of it
759                                         git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$DROPPED"/$rev
760                                         short=$(git rev-list -1 --abbrev-commit --abbrev=7 $rev)
761                                         grep -v "^[a-z][a-z]* $short" <"$TODO" > "${TODO}2" ; mv "${TODO}2" "$TODO"
762                                         rm "$REWRITTEN"/$rev
763                                 fi
764                         done
765                 fi
766
767                 test -s "$TODO" || echo noop >> "$TODO"
768                 cat >> "$TODO" << EOF
769
770 # Rebase $SHORTREVISIONS onto $SHORTONTO
771 #
772 # Commands:
773 #  p, pick = use commit
774 #  e, edit = use commit, but stop for amending
775 #  s, squash = use commit, but meld into previous commit
776 #
777 # If you remove a line here THAT COMMIT WILL BE LOST.
778 # However, if you remove everything, the rebase will be aborted.
779 #
780 EOF
781
782                 has_action "$TODO" ||
783                         die_abort "Nothing to do"
784
785                 cp "$TODO" "$TODO".backup
786                 git_editor "$TODO" ||
787                         die "Could not execute editor"
788
789                 has_action "$TODO" ||
790                         die_abort "Nothing to do"
791
792                 test -d "$REWRITTEN" || skip_unnecessary_picks
793
794                 git update-ref ORIG_HEAD $HEAD
795                 output git checkout $ONTO && do_rest
796                 ;;
797         esac
798         shift
799 done